#include "YoggieEngine.h"
#include "AssetManagerEditor.h"
#include "AssetImporter.h"
using namespace YoggieEngine;

Asset& AssetManagerEditor::GetAsset(AssetHandle handle)
{
    static Asset EmptyAsset{};

    // 1. Check if handle is valid
    if (IsAssetHandleValid(handle) == false)
        return EmptyAsset;

    // 2. check if asset needs loading
    Asset asset;
    if (IsAssetLoaded(handle)) {
        asset = LoadedAssets.at(handle);
    }
    else {
        // Load asset
        // Get MetaData
        //auto& metadata = Assets[handle];

        // Load Asset 
        //asset = AssetImporter::ImportAsset(metadata);

    }
    
    // 3. return asset.
    return  asset;

}

bool AssetManagerEditor::IsAssetHandleValid(AssetHandle handle)
{
    return Assets.find(handle) != Assets.end();
}

bool AssetManagerEditor::IsAssetLoaded(AssetHandle handle ) {
    return LoadedAssets.find(handle) != LoadedAssets.end();
}