#pragma once
#include "Assets/Asset.h"

namespace YoggieEngine {
	class Texture : public Asset {
	public:
		Texture() = default;
		void Load(const std::string texturePath, bool Transparency = false);

		void Bind();
		void Unbind();
		const unsigned int GetID() const { return Id; }
		const ImVec2 getSize() { return {(float)width, (float)height}; }

		AssetType GetType() override { return AssetType::Texture; } 
	private:
		unsigned int Id;
		int width;
		int height;

	};
}
