#include <YoggieEngine.h>
#include "Scene.h"
#include "Entity.h"
using namespace entt;

namespace YoggieEngine{

	Scene::Scene(const std::string& name): name(name) 
	{
	}

	Scene::Scene()
	{
	}

	Scene::~Scene()
	{}

	Entity Scene::AddEntity(std::string name)
	{
		Entity entity = { m_registry.create(), this };

		auto& ident = entity.AddComponent<IdentifierComponent>();
		ident.name = name;
		entity.AddComponent<TransformComponent>();


		return entity;
	}

	void Scene::Start()
	{
		// Execute start functions in scripts etc....
	}

	void Scene::Update()
	{
		// Execute Update functions in scripts etc....
	}

	void Scene::FixedUpdate()
	{
		// Execute step through physics simulation step....

	}

	void Scene::Stop()
	{
		// Execute stop functions in scripts etc....
	}

}
