#pragma once


// Important STL 
#include <string>
#include <list>
#include <iostream>
#include <fstream>
#include <vector>
#include <stdlib.h>
#include <memory>
#include <chrono>

// Important libraries
#include "spdlog/spdlog.h"
#include <glad/glad.h>
#include <glm/glm.hpp>
#include <glm/gtc/matrix_transform.hpp>
#include <glm/gtc/type_ptr.hpp>
#include <imgui.h>
#include <entt/entt.hpp>
#include "Graphics/stb_image.h"


extern "C"
{
	#include "lauxlib.h"
	#include "lua.h"
	#include "lualib.h"
}


// Main library stuff
#include "Platform/Platform.h"

#include "Graphics/Mesh.h"
#include "Graphics/Shader.h"
#include "Graphics/Texture.h"
#include "Graphics/CubeMap.h"
#include "Graphics/Camera.h"
#include "Graphics/Material.h"
#include "Graphics/Renderer.h"

#include "Physics/Physics.h"

#include "Input/Keyboard.h"
#include "Input/InputManager.h"

#include "Scene/Entity.h"
#include "Scene/Scene.h"
#include "Scene/Components.h"
#include "Application.h"

